//------------------------------------------------------------------------
//========================================================================
// JaSeeDC = HTML application for presentation of images and their slide shows  
// in Internet Explorer (version 5.5 or higher)
//========================================================================
// This application was written by Jaroslav Pulpan (pulpanj@volny.cz) as 
// JavaSript exercise. Manual and download page for JaSeeDC is available 
// at http://pulpanj.me.cz/jaseedc/
// Insert this JavaScript into HTML page based on template.htm 
// (from http://pulpanj.me.cz/jaseedc/jaseedc.zip)
//------------------------------------------------------------------------
// The main purpose of this application is simple preparation of HTML pages
// that present set of thumbnail images. The full size image corresponding to the thumbnail 
// could be opened by clicking on the thumbnail. The difference against simple 
// HTML image set generators (available e.g. at ADCD, Adobe Photoshop or by my favourite
// freeware program Batch Thumbs (by HarmWare http://harmware.com) is way of opening 
// of the full size images. These are opened in full screen mode with optimized image resizing
// (original size or reduced to fit screen size). F key always zoom image to size 
// corresponding to the full screen
//------------------------------------------------------------------------
// Other functionality of JaSeeDC is running of the slide show from all images 
// presented by set of thumbnail images. Transition to the next image could be manual
// or automatic after specified delay.
// As name suggest JaSeeDC is trying to simulate slide show capabilities of standard 
// image viewers like ACDC. Could be that it still needs more optimalization of image 
// preloading algorithm - but I tried my best.
//------------------------------------------------------------------------
// compatibility: tested only on IE 5.5 IE6.0
// there was no attempt to write this code compatible with 
// more browsers or their version - JavaScript and DOM support differs too much
// among them
//------------------------------------------------------------------------
// bugfixes
// v1.01 - 6/10/03 -  timer event to check and update thumbnail flyover when picture is loaded
// v1.02 - 7/10/03 -  size of the picture corrected when slideshow controls are on
// v1.03 - 28/10/03 - for TD elements with THUMB title is compred by replacing 
//					  text between <> (and < >) by  new line (&#10) 
//					- full screen background color setting corrected					
//					- panorama viever added 
// v1.04 - 15/05/04 - bug for pages with links only solved
// v1.05 - 15/05/04 - bug for last picture on page  solved
var ver='1.05'
//------------------------------------------------------------------------
// JaSeeDC is freeware without any warranty and without any support
// (c) Jaroalsv Pulpan s.r.o. 2003-2004
//
// default values of the thumb element 
var default_frame_color="black";
var default_label_color="white";
//color of the background for full-size picture 
var default_bgr_color="black";

var show_fullscreen=false;	// full screen flag
var show_controls=false;	// flag - display slide show control panel
var single_image=false;		// flag - just single image was selected
var pics=new Array();		// array of images
var ipic=0;					// pointer to actual image
var now_src; 				// short name of the currently displayed full screen image
var zoomed=false;			// flag - picture zoomed to whole screen
var next_time;	// timer event - full size picture ready (to be canceled if interupted)
var next_test;	// timer event - test if picture was preloaded (to be canceled if interupted)

// this is main JavaScript logic after page was loaded
// it handles expansion of the original TD elements into thumbnail images
// and/or displaying of the full image
function jaseedc() {
	// load appliation into TD (with THUMB attribute) 
	// and into DIV elements (with id="thumbs" or id="full_screen_mode","run_slideshow")
	load_thumbs();
	load_runbutton();
	load_controls();
	
	// process search string that contains name of the image name for full screen mode
	var k=document.location.search.indexOf('?image=') ;
	show_fullscreen=(k != -1);
	if (show_fullscreen) {
		/// ---- full screen mode
		/// hide scroll bar
	    document.all.tags("BODY").item(0).scroll="no"; 
		// find  which picture be displayed
		now_src=document.location.search.substr(k+7);
		// determine which IPIC picture in PICS array we are displaying
		for (ipic=0;ipic<pics.length;ipic++) {
			if (pics[ipic].src == now_src) {
				break;
			}
		}
		// test if we know which picture to display of if slideshow controls 
		single_image=( document.location.search.indexOf('?slideshow') == -1 );
		if ( !single_image ) {
			// display slide show controls
			show_controls=false;
			switch_controls();
		}
		pics[ipic].img.src=pics[ipic].src;
		// set long name of the large image 
		pics[ipic].long_src=pics[ipic].img.src;
		load_ipic(0);
	}
	else {
		// ---- thumb display mode
		thumbs.style.display='';
	}
}

// redisplay current page in full screen mode, add image name and 
// slide show control flag as the search parameters of the page location
function show_full_screen(fullimage,display_controls) {
    var location_params=document.location
	if (display_controls) {
		location_params+='?slideshow';
	}
    location_params+='?image='+fullimage;
	self.open(location_params,"JaSeeDC","fullscreen=1",true);
}

// about window - pure HTML
function about_jaseedc() {
	helpwin=window.open("",'About_JaSeeDC', 'height=480,width=680,left=30,top=50');
	helpwin.document.write(
'<!DOCTYPE HTML PUBLIC "-\/\/W3C\/\/DTD HTML 4.0 Transitional\/\/EN">'
+'<html><head><title>JaSeeDC v'+ver+'</title></head>'
+'<body style="text-align:center; cursor:hand" onKeyDown="window.close();" '
+'bgcolor="Black" text="White" link="Yellow" vlink="Yellow" alink="Fuchsia">'
+'<h3>JaSeeDC v'+ver+' - JavaScript slide show for Internet Explorer 5+</h3>'
+'<HR align=center width="100%">'
+'JaSeeDC was written by Jaroslav Pulpan (<a href="mailto:pulpanj@volny.cz">'
+'pulpanj@volny.cz</a>) as first JavaScript exercise.'
+' JaSeeDC is freeware without any warranty and without any support<br>'
+'<br>Download and manual available at <a href="http:\/\/pulpanj.me.cz\/jaseedc\/" target="blank">'
+'http:\/\/pulpanj.me.cz\/jaseedc\/<\/a>'
+'<br>Let me know if you find JaSeeDC usefull '
+'<HR align=center width="100%">'
+'<table border="1" cellspacing="2" cellpadding="2" style="background-color: Silver; color:black;">'
+'<tr><td colspan="2">HELP - Key and mouse commands in full screen mode </td>'
+'</tr><tr><td>(Escape) <br> Mouse doubleclick</td>'
+'<td>Open slide show controls <br>(next Escape will close full screen window)</td>'
+'</tr><tr><td>(PageUP) </td><td>Previous image</td></tr>'
+'<tr><td>(PageDOWN) <br>  (Space) </td><td>Next image</td></tr>'
+'<tr><td>(Enter)<br> Mouse click</td><td>Close full screen window (Manual image transition mode) <br> or Next image (Automatic slide show mode)</td><tr>'
+'<tr><td>(F)</td><td>Zoom in/out image to full screen size</td>'
+'</tr></table></body></html>'
	);
}

//defines button that starts slideshow
function load_runbutton() {
	if (pics.length>0) {
		// load button that starts slideshow
		var run_button=document.all.run_slideshow;
		run_button.insertAdjacentHTML('AfterBegin',
			'<input type="button" name="Slideshow" '
			+'value="Run this page&#10; as slide show"  '
			+'onclick=\'show_full_screen("'+pics[ipic].src+'",true);\'>'
		);
	}
}

// defines control panel of slideshow
function load_controls() {
	var controls=document.all.slideshow;
	// element of the control center of the slideshow + large_image
	controls.insertAdjacentHTML('AfterBegin',
	 '<div id="slideshow_controls" style="display:\'none\';">'
	+'<table border="1" align="center" style="background-color: Silver; color: Black;">'
	+'<tr><td align="center" colspan="4" >Slide Show Control <\/td>'
	+'<\/tr><tr><td colspan="3">'
		+'<input type="submit" name="start_slideshow"	value="Start slideshow &#10; (Enter)" onclick=\'restartslideshow ();\'> '
		+'<input type="submit" name="prev_img" value="Previous image  &#10; (Page Up)" onclick=\'load_ipic(-1);\'> '
		+'<input type="submit" name="next_img" value="Next image  &#10; (Page Down)" onclick=\'load_ipic(1);\'> '
		+'<input type="submit" name="close_slideshow" value="Close slideshow  &#10;(Escape)" onclick=\'window.self.close();\'> '
	+'<\/td><\/tr><tr><td rowspan="2" align="center">Image <br>transition <\/td>'
	+'<td align="left">'
		+'<input type="radio" name="clickordelay" value="1"> Manually by mouse click or (Space) or (Enter) keys '
	+'<\/td><\/tr><tr>'
	+'<td align="left">'
		+'<input type="radio" name="clickordelay" value="0" checked>Automatically after '
		+'<input type="text" 	name="delay" value="5" size="3" > seconds '
	+'<\/td><\/tr><tr>'
	+'<td colspan="3" align="center">Press F1 for help page about keyboard and mouse commands<\/td> '
	+'<\/tr><\/table><\/div>'
	+'<img id="large_image" style="display:\'none\'; cursor:hand" '
   +'onload="full_size_loaded(this);"  ondblclick="dblclickimage();" onclick="clickimage();"  >'
);
}

// identify all thumb images  on page (defined by TD element with THUMB attribute)
function load_thumbs() {
	//-----------------------------------------------------
	// insert images after all TD tags with thumb property
	var tds=document.all.tags("TD");
	//cycle over all TD elements on page 
	for (var itd=0; itd<tds.length; itd++){
		var td=tds.item(itd);
		//load custom properties of the TD elements
		for (var td_property in td) {
			// TD element should have attribute THUMB to be part of slide show
			if (td_property.toUpperCase() =="THUMB") {
				td.thumb=td[td_property];
			}
		}
		if (td.thumb != null) {
			for (var td_property in td) {
			// try to find another custom parameters of the TD 
			// resolve their case insensitivity in HTML
				if (td_property.toUpperCase() =="FULL_IMAGE") {
					td.full_image=td[td_property];
				}
				if (td_property.toUpperCase() =="ILINK") {
					td.ilink=td[td_property];
				}
				if (td_property.toUpperCase() =="BGR_COLOR") {
					td.bgr_color=td[td_property];
				}
				if (td_property.toUpperCase() =="FRAME_COLOR") {
					td.frame_color=td[td_property];
				}
				if (td_property.toUpperCase() =="LABEL_COLOR") {
					td.label_color=td[td_property];
				}
			}
		}
		//set default values of the images if these were not defined in TD element
		if (td.thumb != null) {
			//if full_name is empty set it equal to thumb and modify thumb 
			//by adding _th
			if (td.full_image == null ) {
				td.full_image=td.thumb;
				// add _th to the thumb image name 
				if (td.ilink == null) {
					var k= td.thumb.lastIndexOf(".");
					if ( k != -1) {
						td.thumb=td.thumb.substr(0,k-1)+"_th"+td.thumb.substr(k);
					}
					else {
						td.thumb +="_th";
					}
				}
			}
			//if thumb parameter do not contain . expand thumb name by .jpg
			k= td.thumb.lastIndexOf(".");
			if ( k == -1) {
				td.thumb +=".jpg";
			}
			// if full_image parameter do not contain . expand thumb name by .jpg
			k= td.full_image.lastIndexOf(".");
			if ( k == -1) {
				td.full_image +=".jpg";
			}
			if (td.frame_color == null) {td.frame_color=default_frame_color};
			if (td.bgr_color   == null) {td.bgr_color=default_bgr_color};
			if (td.label_color == null) {td.label_color=default_label_color};
			// remove original text (will be moved to inner thumb image table)
			td.label=td.innerHTML;
			td.innerHTML=" ";
			
			if (td.ilink != null) {
			// handle optional ILINK attribute
				var sa1='<A HREF="'+td.ilink+'">';
				var sa2='</A>';
				var sa3='alt="Link to: '+td.label+'" ';
				var sa4=" ";
			}
			else {
				// define pics element objects to be used for loading full screen images
				pics[pics.length]=new Object;
				pics[pics.length-1]= {
					src:td.full_image,
					img: new Image(),
					thumb:td.thumb,
					long_thumb:null,
					// replace tags within label with new lines
					label:td.label.replace(/(<[^>]*>[.\s]*)+/g,"\n").replace(/\n$/,""),
					alt:td.full_image+"\n[Loading]",
					bgrcol:td.bgr_color,
					preloaded:false
				};
				sa1=" ";sa2=" ";
				sa3='onclick=\'show_full_screen("'
				+td.full_image+'",false);\' onMouseover=\'test_preload_full('+(pics.length-1)+');\' ';
				sa4='name="TH'+(pics.length)+'"';
			}
			////window.alert(td.thumb);
			/// insert thumb images as centered tables into their TD elements		
			////window.alert('name="TH'+(pics.length)+'" ');	
				td.insertAdjacentHTML('AfterBegin',
				'<TABLE cellSpacing=5 align=center border=0>' 
				+'<TBODY><TR><td align=middle width="220" height="250"' 
				+'style="background-color: Gray; color: '+td.label_color+';" > '
				+sa1+'<img  '+sa4+' src="'+td.thumb+'" onload="set_thumb_size(this);" '
				+'style="cursor:hand" style="border: solid '+td.frame_color+';" '
				+sa3+'><br>'+td.label+sa2+'</td></TR></TBODY></TABLE>'
			);
		}
	}
}

// reset thumb size to max. 205 pixels
function set_thumb_size(thumb_img) {
	var ip=find_thumb(thumb_img)-1;
	// set full thumb image name
	////window.alert(pics.length+' '+ip);
	if (pics.length>0) {
		pics[ip].long_thumb=thumb_img.src};
		//redefine size
		var h=thumb_img.height;
		var w=thumb_img.width;
		// squeeze thumb to max. size 205 pixels
		if (h>205) { w=w*205/h; h=205};
		if (w>205) { h=h*205/w; w=205};
		thumb_img.height=h;
		thumb_img.width=w;
}


//find thumb position in pics array
function find_thumb(thumb_img) {
	for (var ip=0;ip<pics.length;ip++) {
		if ( ("TH"+ip+1)==thumb_img.name) {
			break;
		}
	}
	return ip;
}

// if mouse went over thumbnail start preload of the full image 
function test_preload_full(ip){
	window.clearTimeout(next_time);
	var	thumb_img=document.all.item('TH'+(ip+1));
	pics[ip].long_thumb=thumb_img.src;
	///window.alert(ip+' '+pics[ip].long_thumb);
	if ( pics[ip].img.complete ) {
		thumb_img.style.cursor="hand";
		set_alt(ip);
	} 
	else {
		if ( ! pics[ip].img.src ) {
			pics[ip].img.src=pics[ip].src;
			thumb_img.style.cursor="wait";
		}
	next_test=window.setTimeout('test_preload_full('+ip+');',1000);
	}
	thumb_img.alt=pics[ip].alt;
}

// set flyover to full image info
function set_alt(ip) {
	if (pics[ip].label.length != 0) {
		pics[ip].alt=pics[ip].label+"\n";
	}
	else {
		pics[ip].alt='';
	}
	pics[ip].alt+=pics[ip].src+"\n"+pics[ip].img.width+" x "
			+pics[ip].img.height+" pixels\n"
	var isize=pics[ip].img.fileSize;
	if (isize > 0 ) {
		pics[ip].alt+=kBMB(isize)+"\n("+numx(isize)+" Bytes)";
	}
}

// onload handler for full screen image
function full_size_loaded(full_img) {
	if (show_fullscreen) {
		pics[ipic].img.src=pics[ipic].src;
		set_alt(ipic);
		large_image.alt=pics[ipic].alt
		// fit size of picture
//		if ( (! single_image) && show_controls ) {
		if ( show_controls ) {
			// display includes slide show controls set h=300
			var iw=pics[ipic].img.width;
			var ih=pics[ipic].img.height;
			if (ih>300) { iw=iw*300/ih; ih=300};
			if (iw>300) { ih=ih*300/iw; iw=300};
			large_image.height=ih;
			large_image.width=iw;
			large_image.style.position='static';
		}
		else {
			// set size to fit to screen or set it to original size
			 zoom(false);
		}
		// initialize load of the next image
		kpic=ipic+1;
		/// v1.05
		///window.alert(ipic+' '+kpic+' '+pics.length);
		if ( kpic == pics.length ) {kpic= 0};
		pics[kpic].img.src=pics[kpic].src;
	}
}

function load_ipic(direction) {
	window.clearTimeout(next_time);
	ipic+=direction;
	if ( ipic < 0 ) {ipic=pics.length-1};
	if ( ipic == pics.length ) {ipic= 0};
	if ( ! pics[ipic].img.src) {
		pics[ipic].img.src=pics[ipic].src;
	}
	// set bgr color
		document.body.bgColor=pics[ipic].bgrcol;
	// test if ipic image is completely loaded
	if ( ! pics[ipic].img.complete ) {
		//if not set cursor shape and set short timeout check
		large_image.style.cursor="wait";
		// and wait for its loading
		next_time=window.setTimeout('load_ipic(0);',100);
		return;
	}
	else {
		//if it is loaded reset cursor shape
		large_image.style.cursor="hand";
	//display large_image
	large_image.src=pics[ipic].src;
	// set long name of the large image 
	pics[ipic].long_src=large_image.src;
	large_image.alt=pics[ipic].alt;
	large_image.style.display='';
	if (document.all['clickordelay'].item(1).checked && !show_controls && !single_image ) {
		var del=document.all['delay'].value;
		next_time=window.setTimeout('load_ipic(1);',del*1000);
	}
	}
}

function restartslideshow () {
	switch_controls ();
	if (document.all['clickordelay'].item(1).checked && !single_image ) {
		var del=document.all['delay'].value;
		if (del=="") {
			window.alert("Invalid delay, insert valid number");
			del=5;
			document.all['delay'].value=del;
			document.all['delay'].focus;
		}
		else {
			next_time=window.setTimeout('load_ipic(1);',del*1000);
		}
	}
}		


// print number in the format that separates 3 digict by ,
function numx(x) {
	var s;
	if ( typeof x == "string" ) {
		s=x;
	} else {
		s=x.toFixed();
	}
	var k=(s.length);
	var sr="";
	for (var i=0;i<k;i++) {
	var s1=s.substr(k-i-1,1);
	sr=s1+sr;
	if ((i%3 == 2) && (i<(k-1)) ) sr=","+sr;
	}
	return sr;
}	

// write Kb or Mb in "nice" form
function kBMB(x) {
	var s;
	if (x>Math.pow(2,19)) {
		s=(x/Math.pow(2,20)).toPrecision(3)+" MB";
	}
	else {
		s=(x/Math.pow(2,10)).toPrecision(3)+" kB";
	}
	return s;
}


function zoom(flag){
	var iw=pics[ipic].img.width;
	var ih=pics[ipic].img.height;
	var sw=screen.width;
	var sh=screen.height;
	if (flag) {
		if (ih/sh > iw/sw ) { 
			iw=iw*sh/ih; ih=sh; 
		} else {
			ih=ih*sw/iw; iw=sw; 
		}
	}
	else {
	// set original picture size or resize to full screen
		if (ih>sh) { iw=iw*sh/ih; ih=sh};
		if (iw>sw) { ih=ih*sw/iw; iw=sw};
	}
	large_image.height=ih;
	large_image.width=iw;
	large_image.style.position='absolute';
	large_image.style.left=(sw-iw)/2;
	large_image.style.top=(sh-ih)/2;
	zoomed=flag;
}

// show/hide slide show controls
function switch_controls () {
	if (show_controls) {
		//awitch off controls
		single_image=false;
		slideshow_controls.style.display='none';
		zoom(false);
	}
	else {
		window.clearTimeout(next_time);
		//awitch on controls
		var iw=large_image.width;
		var ih=large_image.height;
		//	alert (iw+' '+ih+' ');
		if (ih>300) { iw=iw*300/ih; ih=300};
		large_image.height=ih;
		large_image.width=iw;
		large_image.style.position='static';
		slideshow_controls.style.display='';
	}
	show_controls=(!show_controls);
}



function clickimage() {
//mouse click handler for large image
	if ( show_fullscreen ) {
		if (!show_controls) {
			if (single_image) {
				window.self.close();
			}
			else {
				load_ipic(1); 		
			}
		}
		else {
			restartslideshow ();
		} 
	}
}

function dblclickimage() {
//mouse double click handler for large image
	if ( show_fullscreen ) {
		if (!show_controls) {
				switch_controls ();
		}
		else {
				window.self.close();
		}
	}
}

function keyhandler() {
	var F_key=70;
	var Esc_key=27;
	var Enter_key=13;
	var Space_key=32;
	var PgUp_key=33;
	var PgDw_key=34;
	
	if ( show_fullscreen ) {
		if (!show_controls) {
			// we are displaying just large image
			if ( event.keyCode == F_key ) {
				zoom( ! zoomed );
			} 
			else if ( event.keyCode == Esc_key) {
				switch_controls ();
			}
			else if ( event.keyCode == Enter_key ) {
				if (single_image) {
					window.self.close();
				}
				else {
					load_ipic(1); 		
				}
			}
		}
		else {
			// keyboard commands when controls are visible
			// next image in zoomed view
			if  ( (event.keyCode == Enter_key)  ) {
				restartslideshow ();
			} 
			else if ( event.keyCode == Esc_key) {
				window.self.close();
			} 
		}
		if ( (event.keyCode == Space_key) || event.keyCode == PgDw_key) {
			load_ipic(1) ;		
		}
		else if ( event.keyCode == PgUp_key) {
			load_ipic(-1); 		
		}
	}
	return false;
}
//------------------------------------------------------
// panoramatical picture viewer
//------------------------------------------------------
function popwide(image,label,bgcolor,fgcolor) {
	wide=open('','fulll','fullscreen=1',true);
	var k= image.lastIndexOf(".");
	if ( k == -1) {
		image=image+".jpg";
		}
	if (bgcolor  == null) bgcolor=default_bgr_color;
	if (fgcolor  == null) fgcolor= default_label_color;
	var sw=screen.width;
	var sh=screen.height-60;
	wide.document.write(
'<html><BODY bgColor="'+bgcolor+'" text="'+fgcolor+'" > '
+'<table border=1 width="100%"><td align="center" width="100%"><bold>'+label+'</bold></td>'
+'<td align="right" nowrap><input type="button" value="Close viewer" onclick="window.close()"></td></table>'
+'<span align="center"><iframe width="'+sw+'" src="'+image+'" '
+'height="'+sh+'" marginwidth="2" marginheight="2" '
+'align="middle" title="'+label+'" >'
+'</iframe></span></body></html>'
	);
    wide.document.all.tags("BODY").item(0).scroll="no"; 
}
